{
	returncodes:
		0         : No error
		0 - 23    : Current Hour
		32        : User break
}

{$M 8192,0,0}
program
	chour;
uses
	nya;
type
	string2				=	string[2];
	string4				=	string[4];
const
	ver					:	string2 = '1';
	rev					:	string2 = '0';
	version				:	string[64] = '$VER: chour 1.0 (6.8.95) Copyright (C)1995-96 Fredrik Wangel';
	ampm					:	array[1..2] of string2 = ('am', 'pm');
var
	y1,
	m1,
	d1,
	w1,
	j1,
	y2,
	m2						:	word;
	c1,
	c2						:	string;
	int1Bsave			:	pointer;

{$F+}
procedure _break_handler; interrupt;
	begin
		printstrln('^C');
		setvector($1B, int1Bsave);
		halt(32);
	end;
FUNCTION CursX : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DL
		MOV	AL, DL
	END;
FUNCTION CursY : Byte ; ASSEMBLER;
	ASM
		MOV	AX,0300h				(* Get Cursor Position *)
		MOV	BH,0					(* Page number *)
		INT	10h
		INC	DH
		MOV	AL, DH
	END;
function Pad(i : word; j : byte): string4;
	begin
		Pad[0] := chr(j);
		while j > 0 do
		begin
			Pad[j] := chr(i mod 10 + ord('0'));
			i := i div 10;
			dec(j);
		end;
	end;
function Dig(i : word; j : byte) : string4;
	var
		s				:	string4;
	begin
		str(i, s);
		s := copy(s, length(s) - j + 1, j);
		while ((s[1] = '0') and (length(s) > 1)) do delete(s, 1, 1);
		dig := s;
	end;

begin
	getvector($1B, int1Bsave);
	setvector($1B, addr(_break_handler));
	if paramstr(1) = '/?' then begin
		printstrln('CHour v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('Usage: CHour [/12]');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	if paramstr(1) = '/!' then begin
		printstrln('         CHour v' + ver + '.' + rev + ' (C)1995-96 Fredrik Wangel');
		printstrln('');
		printstrln('CHour returns the current hour in either 12 or 24 hour');
		printstrln('format. Default is 24  but if the parameter /12 is put');
		printstrln('on the commandline then 12 hour clock will be used and');
		printstrln('either  AM or PM  will be  appended when  appropriate.');
		printstrln('The returncode is set to  the current hour so that you');
		printstrln('test it in a batchfile.');
		printstrln('You can redirect  the output using the standard MS-DOS');
		printstrln('output redirection character ( > ).  For  instance  to');
		printstrln('output to  the printstrer  you would  type  "CHOUR >prn".');
		printstrln('');
		setvector($1B, int1Bsave);
		halt(0);
	end;
	XGetTime(y1, m1, d1, w1);
	if y1 > 12 then j1 := y1 - 12 else j1 := y1;
	if y1 = 0 then j1 := 12;
	if cursx <> 1 then printstrln('');
	if paramstr(1) = '/12' then begin
		if y1 >= 12 then c2 := ampm[2] else c2 := ampm[1];
		printstrln(dig(j1, 2) + c2);
		setvector($1B, int1Bsave);
		halt(j1);
	end;
	printstrln(dig(y1, 2));
	setvector($1B, int1Bsave);
	halt(y1);
end.
