USES
	NYA;
VAR
	D	:	BYTE;
	C	:	STRING[1];

PROCEDURE Usage;
BEGIN
	PrintStrLn(#13#10'Copyright (C)1996 Fredrik Wangel'#13#10'Usage: DRVOFF [d:]'#13#10 +
					'  d: is the drive to disable, eg A, C or Z');
END;

BEGIN
	IF PARAMCOUNT > 0 THEN BEGIN
		C := COPY(PARAMSTR(1), 1, 1);
		D := ORD(UPCASE(C[1])) - 65;
		IF NOT D IN [0..25] THEN
			Usage
		ELSE
			IF NOT DisableDrive(D) THEN
				PrintStrLn('Could not disable drive ' + CHR(D + 65) + ':')
			ELSE
				PrintStrLn('Drive ' + CHR(D + 65) + ': has been disabled.');
	END
	ELSE
		Usage;
END.
