PROGRAM SETBORDC;

USES
	NYA;

VAR
	A		:	BYTE;
	B		:	INTEGER;

PROCEDURE SetBorderColor(Color : BYTE); ASSEMBLER;
	ASM
		MOV	AX, 1001h
		MOV	BH, [Color]
		INT	10h
	END;

BEGIN
	IF (PARAMCOUNT = 0) OR (POS('?', PARAMSTR(1)) <> 0) THEN BEGIN
		PRINTSTRLN('SETBORDC [color]');
		PRINTSTRLN('color is the index of the colorregister to apply on border.');
		PRINTSTRLN('Eg SETBORDC 2 will (probably) set it to a green color.');
		PRINTSTRLN('Copyright (C)1995-96 Fredrik Wangel');
		HALT(0);
	END;
	VAL(PARAMSTR(1), A, B);
	IF (B <> 0) THEN BEGIN
		PRINTSTRLN('Error while converting ' + PARAMSTR(1) + ' to a number (0-255)');
		HALT(1);
	END;
	SetBorderColor(A);
END.
