{$M 8192, 0, 16384}
program	sp;
uses		dos,
			crt;
const		ver		:	string = '$VER: sp 1.01 (29.01.96) Copyright (c)1995-96 Fredrik Wangel'#0#0;
type		st3		=	string[3];
var		filin		:	file;
			filut		:	file;
			index		:	text;
			filnamn	:	string;
			basnamn	:	string;
			ss			:	string;
			i,
			j,
			jj,
			how,
			m,
			nbw,
			bip,
			lbip		:	longint;
			nr,
			nw			:	Word;
			Buf		:	array[1..32768] of Char;

procedure goExternal(cmd : string);
	var
		path	:	pathstr;
		aa		,
		bb		:	string;
	begin
		{$I-}
		aa := copy(cmd, 1, pos(' ', cmd) - 1);
		bb := copy(cmd, pos(' ', cmd) + 1, length(cmd));
		swapvectors;
		exec('C:\DOS\COMMAND.COM', '/C ' + aa + ' ' + bb);
		swapvectors;
	end;

function znum(i : longint; a : byte) : string;
	var	j			:	byte;
			b			:	string;
	begin
		str(i:a, b);
		for j := 1 to a do if b[j] = ' ' then b[j] := '0';
		znum := b;
	end;

function atoi(sss : string) : longint;
	var	a	:	longint;
			b	:	integer;
	begin
		val(sss, a, b);
		if b <> 0 then a := -1;
		atoi := a;
	end;

begin
	if paramcount <> 3 then begin
		writeln(ver);
		writeln('');
		writeln('usage: sp file basename pieces');
		writeln('       will split file into  pieces  parts and');
		writeln('       name them  basename.!xx  where  xx is a');
		writeln('       number from 0..40.  Previous files with');
		writeln('       such names will be deleted first.');
		halt(1);
	end;
	filnamn := paramstr(1);
	basnamn := paramstr(2) + '.';
	m := atoi(paramstr(3));
	if m = 1 then begin
		writeln('can not split into 1 file!');
		halt(4);
	end;
	if m > 40 then begin
		writeln('can not split into more than 40 files!');
		halt(4);
	end;
	{$I-}
	assign(filin, filnamn);
	reset(filin, 1);
	if ioresult <> 0 then begin
		writeln('error while opening ', filnamn, '...');
		halt(5);
	end;
	if filesize(filin) div m = 0 then begin
		writeln('to many parts for split!');
		halt(4);
	end;
	writeln('deleting previous ' + basnamn + '!xx files...');
	goExternal('DEL >NUL ' + basnamn + '!??');
	bip  := filesize(filin) div m;
	lbip := filesize(filin) mod m;
	ss   := '';
	for i := 1 to m - 1 do begin
		ss := ss + znum(bip, 6);
	end;
	ss := ss + znum(bip + lbip, 6);
	writeln('creating ', m, ' files...');
	for i := 0 to m - 1 do begin
		j := atoi(copy(ss, 1, 6));
		nbw := 0;
		assign(filut, basnamn + '!' + znum(i, 2));
		rewrite(filut, 1);
		if ioresult <> 0 then begin
			writeln('error while creating ', basnamn + '!' + znum(i, 2), '...');
			halt(5);
		end;
		how := j;
		jj := j;
		repeat
			BlockRead(filin, Buf, how, nr);
			BlockWrite(filut, Buf, nr, nw);
			nbw := nbw + nw;
			write(#13'writing ', basnamn + '!' + znum(i, 2), ' (', znum(nbw, 10), ')');
			clreol;
			how := jj - j + 1;
			jj := how;
			if how > j + 1 then how := j + 1;
		until (nr = 0) or (nw <> nr) or (nbw = j);
		close(filut);
		delete(ss, 1, 6);
	end;
	write(#13);
	clreol;
	assign(index, 'joinm.bat');
	rewrite(index);
	if ioresult <> 0 then begin
		writeln('error while creating joinm.bat...');
		halt(5);
	end;
	writeln('creating JOINM.BAT...');
	writeln(index, '@ECHO OFF');
	writeln(index, 'IF "%1"=="" GOTO stop');
	writeln(index, 'COPY /B ' + basnamn + '!* /B %1');
	writeln(index, 'GOTO ok');
	writeln(index, ':stop');
	writeln(index, 'ECHO usage: joinm FILE');
	writeln(index, 'ECHO FILE is the file to create.');
	writeln(index, 'ECHO It will join all the ' + basnamn + '!* files.');
	writeln(index, ':ok');
	close(index);
	close(filin);
	writeln('done.');
end.
