program felinfo;

var
	s,
	kod			:	integer;

begin
	if paramstr(1)='/?' then begin
		writeln('Borland Pascal  Version 7.0  Run-Time Error Messages');
		writeln('WHY v1.00 Copyright (C)1994 Fredrik Wangel');
		writeln('Usage: WHY [nnn]');
		writeln('       where nnn is a error number between 1 and 999');
		halt(0);
	end;
	val(paramstr(1), s, kod);
	if kod = 0 then begin
		write('      Unknown'#13'Error ');
		if s =   1 then write('  1 : Invalid function number');
		if s =   2 then write('  2 : File not found');
		if s =   3 then write('  3 : Path not found');
		if s =   4 then write('  4 : Too many open files');
		if s =   5 then write('  5 : File access denied');
		if s =   6 then write('  6 : Invalid file handle');
		if s =  12 then write(' 12 : Invalid file access code');
		if s =  15 then write(' 15 : Invalid drive number');
		if s =  16 then write(' 16 : Cannot remove current directory');
		if s =  17 then write(' 17 : Cannot rename across drives');
		if s =  18 then write(' 18 : No more files');
		if s = 100 then write('100 : Disk read error');
		if s = 101 then write('101 : Disk write error');
		if s = 102 then write('102 : File not assigned');
		if s = 103 then write('103 : File not open');
		if s = 104 then write('104 : File not open for input');
		if s = 105 then write('105 : File not open for output');
		if s = 106 then write('106 : Invalid numeric format');
		if s = 150 then write('150 : Disk is write-protected');
		if s = 151 then write('151 : Bad drive request struct length');
		if s = 152 then write('152 : Drive not ready');
		if s = 154 then write('154 : CRC error in data');
		if s = 156 then write('156 : Disk seek error');
		if s = 157 then write('157 : Unknown media type');
		if s = 158 then write('158 : Sector Not Found');
		if s = 159 then write('159 : Printer out of paper');
		if s = 160 then write('160 : Device write fault');
		if s = 161 then write('161 : Device read fault');
		if s = 162 then write('162 : Hardware failure');
		if s = 200 then write('200 : Division by zero');
		if s = 201 then write('201 : Range check error');
		if s = 202 then write('202 : Stack overflow error');
		if s = 203 then write('203 : Heap overflow error');
		if s = 204 then write('204 : Invalid pointer operation');
		if s = 205 then write('205 : Floating point overflow');
		if s = 206 then write('206 : Floating point underflow');
		if s = 207 then write('207 : Invalid floating point operation');
		if s = 208 then write('208 : Overlay manager not installed');
		if s = 209 then write('209 : Overlay file read error');
		if s = 210 then write('210 : Object not initialized');
		if s = 211 then write('211 : Call to abstract method');
		if s = 212 then write('212 : Stream registration error');
		if s = 213 then write('213 : Collection index out of range');
		if s = 214 then write('214 : Collection overflow error');
		if s = 215 then write('215 : Arithmetic overflow error');
		if s = 216 then write('216 : General Protection fault');
	end
	else begin
		write('Please use a number between 1 and 999 as the first parameter!');
	end;
	writeln;
end.
